// This is the C header file.  It contains the prototypes and constants that
// are used in the runtime routines.  The ifndef/define lines below provide an
// interlock so that the contents of this file will be parsed exactly once
// even if it is #included in more than one place within the same source file.

// How to use this file:  Be sure to #include it before library.c.  See the
// example source files.  Only #include library.c once, but #include this file
// in any other source files that contain calls to kernel extensions.

// the following are useful to transform a 32-bit xaddr into separate 16-bit addr, page
#ifndef XADDR_TO_ADDR
#define XADDR_TO_ADDR(xaddress)    ((uint) (0xFFFF & (xaddress)))
#define XADDR_TO_PAGE(xaddress)    ((int) (0xFF & ((xaddress)>>16)))

#endif  //   XADDR_TO_ADDR

#ifndef __KERNEL_EXTENSION_HEADER_FILE__  // The #endif will be in the postamble file
#define __KERNEL_EXTENSION_HEADER_FILE__

// ----Beginning of package memory allocation listing----
// Package GUI_Toolkit_QSC_v1.92  Code: 070000 - 07345a Vars: 008e00 - 008e0a
// Package EtherWiFi_v2.3         Code: 0d0000 - 0d646e Vars: 008e0c - 008e64
// ----End of package memory allocation listing----
#pragma option nowarn=dup
#asm
.VarStart:  equ  $8e64
#endasm
#pragma option warn=dup
// Variables for Kernel Extension Package: GUI_Toolkit_QSC
// Symbols for Kernel Extension Package: GUI_Toolkit_QSC
#define                                            BUTTON_DRAW_XADDR   0x0709bf
#define                                             BUTTON_DRAW_PAGE   0x0007
#define                                             BUTTON_DRAW_ADDR   0x09bf
#define                                   BUTTON_DRAW_TEXTONLY_XADDR   0x0708eb
#define                                    BUTTON_DRAW_TEXTONLY_PAGE   0x0007
#define                                    BUTTON_DRAW_TEXTONLY_ADDR   0x08eb
#define                                           BUTTON_ERASE_XADDR   0x070ac9
#define                                            BUTTON_ERASE_PAGE   0x0007
#define                                            BUTTON_ERASE_ADDR   0x0ac9
#define                                  BUTTON_ERASE_TEXTONLY_XADDR   0x070a34
#define                                   BUTTON_ERASE_TEXTONLY_PAGE   0x0007
#define                                   BUTTON_ERASE_TEXTONLY_ADDR   0x0a34
#define                                           BUTTON_PRESS_XADDR   0x070b3e
#define                                            BUTTON_PRESS_PAGE   0x0007
#define                                            BUTTON_PRESS_ADDR   0x0b3e
#define                                         BUTTON_RELEASE_XADDR   0x070c64
#define                                          BUTTON_RELEASE_PAGE   0x0007
#define                                          BUTTON_RELEASE_ADDR   0x0c64
#define                                          BUTTON_REPEAT_XADDR   0x070c30
#define                                           BUTTON_REPEAT_PAGE   0x0007
#define                                           BUTTON_REPEAT_ADDR   0x0c30
#define                                  CALIBRATE_TOUCHSCREEN_XADDR   0x0716c6
#define                                   CALIBRATE_TOUCHSCREEN_PAGE   0x0007
#define                                   CALIBRATE_TOUCHSCREEN_ADDR   0x16c6
#define                                         CLEAR_GRAPHICS_XADDR   0x070202
#define                                          CLEAR_GRAPHICS_PAGE   0x0007
#define                                          CLEAR_GRAPHICS_ADDR   0x0202
#define                                            CLEAR_PIXEL_XADDR   0x07114c
#define                                             CLEAR_PIXEL_PAGE   0x0007
#define                                             CLEAR_PIXEL_ADDR   0x114c
#define                                             CLEAR_TEXT_XADDR   0x070229
#define                                              CLEAR_TEXT_PAGE   0x0007
#define                                              CLEAR_TEXT_ADDR   0x0229
#define                                         CONFIG_DISPLAY_XADDR   0x070345
#define                                          CONFIG_DISPLAY_PAGE   0x0007
#define                                          CONFIG_DISPLAY_ADDR   0x0345
#define                                    DIRECT_DRAW_GRAPHIC_XADDR   0x07060b
#define                                     DIRECT_DRAW_GRAPHIC_PAGE   0x0007
#define                                     DIRECT_DRAW_GRAPHIC_ADDR   0x060b
#define                                   DIRECT_ERASE_GRAPHIC_XADDR   0x0706a6
#define                                    DIRECT_ERASE_GRAPHIC_PAGE   0x0007
#define                                    DIRECT_ERASE_GRAPHIC_ADDR   0x06a6
#define                                     DIRECT_RENDER_FONT_XADDR   0x0732d8
#define                                      DIRECT_RENDER_FONT_PAGE   0x0007
#define                                      DIRECT_RENDER_FONT_ADDR   0x32d8
#define                                              DO_BUTTON_XADDR   0x070d26
#define                                               DO_BUTTON_PAGE   0x0007
#define                                               DO_BUTTON_ADDR   0x0d26
#define                                             DO_GRAPHIC_XADDR   0x0707b5
#define                                              DO_GRAPHIC_PAGE   0x0007
#define                                              DO_GRAPHIC_ADDR   0x07b5
#define                                                DO_MENU_XADDR   0x070e74
#define                                                 DO_MENU_PAGE   0x0007
#define                                                 DO_MENU_ADDR   0x0e74
#define                                           DRAW_GRAPHIC_XADDR   0x0705af
#define                                            DRAW_GRAPHIC_PAGE   0x0007
#define                                            DRAW_GRAPHIC_ADDR   0x05af
#define                                          ERASE_GRAPHIC_XADDR   0x070755
#define                                           ERASE_GRAPHIC_PAGE   0x0007
#define                                           ERASE_GRAPHIC_ADDR   0x0755
#define                                        GLOBALIZE_TVARS_XADDR   0x072572
#define                                         GLOBALIZE_TVARS_PAGE   0x0007
#define                                         GLOBALIZE_TVARS_ADDR   0x2572
#define                                       GRAPHIC_TO_IMAGE_XADDR   0x072841
#define                                        GRAPHIC_TO_IMAGE_PAGE   0x0007
#define                                        GRAPHIC_TO_IMAGE_ADDR   0x2841
#define                                     HAS_SCREEN_CHANGED_XADDR   0x072c58
#define                                      HAS_SCREEN_CHANGED_PAGE   0x0007
#define                                      HAS_SCREEN_CHANGED_ADDR   0x2c58
#define                                           INIT_DISPLAY_XADDR   0x0703b1
#define                                            INIT_DISPLAY_PAGE   0x0007
#define                                            INIT_DISPLAY_ADDR   0x03b1
#define                                              INIT_MENU_XADDR   0x071031
#define                                               INIT_MENU_PAGE   0x0007
#define                                               INIT_MENU_ADDR   0x1031
#define                                             INIT_TOUCH_XADDR   0x0730f8
#define                                              INIT_TOUCH_PAGE   0x0007
#define                                              INIT_TOUCH_ADDR   0x30f8
#define                                             IS_PRESSED_XADDR   0x07158a
#define                                              IS_PRESSED_PAGE   0x0007
#define                                              IS_PRESSED_ADDR   0x158a
#define                                           MENU_INSTALL_XADDR   0x070f28
#define                                            MENU_INSTALL_PAGE   0x0007
#define                                            MENU_INSTALL_ADDR   0x0f28
#define                                           MENU_PROCESS_XADDR   0x072eef
#define                                            MENU_PROCESS_PAGE   0x0007
#define                                            MENU_PROCESS_ADDR   0x2eef
#define                                             MENU_QUERY_XADDR   0x0730f4
#define                                              MENU_QUERY_PAGE   0x0007
#define                                              MENU_QUERY_ADDR   0x30f4
#define                                            MENU_REMOVE_XADDR   0x070fc9
#define                                             MENU_REMOVE_PAGE   0x0007
#define                                             MENU_REMOVE_ADDR   0x0fc9
#define                                        READ_RAW_COORDS_XADDR   0x071676
#define                                         READ_RAW_COORDS_PAGE   0x0007
#define                                         READ_RAW_COORDS_ADDR   0x1676
#define                                       READ_TOUCHSCREEN_XADDR   0x0715f9
#define                                        READ_TOUCHSCREEN_PAGE   0x0007
#define                                        READ_TOUCHSCREEN_ADDR   0x15f9
#define                                            RENDER_FONT_XADDR   0x0732c4
#define                                             RENDER_FONT_PAGE   0x0007
#define                                             RENDER_FONT_ADDR   0x32c4
#define                                  RENDER_FONT_TO_BUFFER_XADDR   0x073199
#define                                   RENDER_FONT_TO_BUFFER_PAGE   0x0007
#define                                   RENDER_FONT_TO_BUFFER_ADDR   0x3199
#define                                     SCREEN_HAS_CHANGED_XADDR   0x072c4e
#define                                      SCREEN_HAS_CHANGED_PAGE   0x0007
#define                                      SCREEN_HAS_CHANGED_ADDR   0x2c4e
#define                                        SCREEN_TO_IMAGE_XADDR   0x072582
#define                                         SCREEN_TO_IMAGE_PAGE   0x0007
#define                                         SCREEN_TO_IMAGE_ADDR   0x2582
#define                                          SERVICE_TOUCH_XADDR   0x072cfe
#define                                           SERVICE_TOUCH_PAGE   0x0007
#define                                           SERVICE_TOUCH_ADDR   0x2cfe
#define                                       SET_CURSOR_STATE_XADDR   0x0702af
#define                                        SET_CURSOR_STATE_PAGE   0x0007
#define                                        SET_CURSOR_STATE_ADDR   0x02af
#define                                       SET_DISPLAY_MODE_XADDR   0x070296
#define                                        SET_DISPLAY_MODE_PAGE   0x0007
#define                                        SET_DISPLAY_MODE_ADDR   0x0296
#define                                      SET_DISPLAY_STATE_XADDR   0x0702f2
#define                                       SET_DISPLAY_STATE_PAGE   0x0007
#define                                       SET_DISPLAY_STATE_ADDR   0x02f2
#define                                            SET_GR_AREA_XADDR   0x070286
#define                                             SET_GR_AREA_PAGE   0x0007
#define                                             SET_GR_AREA_ADDR   0x0286
#define                                       SET_GR_HOME_ADDR_XADDR   0x070266
#define                                        SET_GR_HOME_ADDR_PAGE   0x0007
#define                                        SET_GR_HOME_ADDR_ADDR   0x0266
#define                                              SET_PIXEL_XADDR   0x07110f
#define                                               SET_PIXEL_PAGE   0x0007
#define                                               SET_PIXEL_ADDR   0x110f
#define                                          SET_TEXT_AREA_XADDR   0x070276
#define                                           SET_TEXT_AREA_PAGE   0x0007
#define                                           SET_TEXT_AREA_ADDR   0x0276
#define                                     SET_TEXT_HOME_ADDR_XADDR   0x070256
#define                                      SET_TEXT_HOME_ADDR_PAGE   0x0007
#define                                      SET_TEXT_HOME_ADDR_ADDR   0x0256
#define                                          SET_TEXT_MODE_XADDR   0x070335
#define                                           SET_TEXT_MODE_PAGE   0x0007
#define                                           SET_TEXT_MODE_ADDR   0x0335
#define                               SIMULATED_TOUCH_TO_IMAGE_XADDR   0x072c5f
#define                                SIMULATED_TOUCH_TO_IMAGE_PAGE   0x0007
#define                                SIMULATED_TOUCH_TO_IMAGE_ADDR   0x2c5f
#define                                         SIMULATE_TOUCH_XADDR   0x072b46
#define                                          SIMULATE_TOUCH_PAGE   0x0007
#define                                          SIMULATE_TOUCH_ADDR   0x2b46
#define                                            STD_DISPLAY_XADDR   0x070546
#define                                             STD_DISPLAY_PAGE   0x0007
#define                                             STD_DISPLAY_ADDR   0x0546
#define                                            UNINIT_MENU_XADDR   0x071070
#define                                             UNINIT_MENU_PAGE   0x0007
#define                                             UNINIT_MENU_ADDR   0x1070
#define                                        UPDATE_GRAPHICS_XADDR   0x0701aa
#define                                         UPDATE_GRAPHICS_PAGE   0x0007
#define                                         UPDATE_GRAPHICS_ADDR   0x01aa
#define                                       UPDATE_HERE_WITH_XADDR   0x070166
#define                                        UPDATE_HERE_WITH_PAGE   0x0007
#define                                        UPDATE_HERE_WITH_ADDR   0x0166
#define                                            UPDATE_TEXT_XADDR   0x0701d1
#define                                             UPDATE_TEXT_PAGE   0x0007
#define                                             UPDATE_TEXT_ADDR   0x01d1
#define                               UPDATE_TEXT_AND_GRAPHICS_XADDR   0x0701f8
#define                                UPDATE_TEXT_AND_GRAPHICS_PAGE   0x0007
#define                                UPDATE_TEXT_AND_GRAPHICS_ADDR   0x01f8
#define                                         WAIT_FOR_PRESS_XADDR   0x07159a
#define                                          WAIT_FOR_PRESS_PAGE   0x0007
#define                                          WAIT_FOR_PRESS_ADDR   0x159a
#define                                       WAIT_FOR_RELEASE_XADDR   0x0715bb
#define                                        WAIT_FOR_RELEASE_PAGE   0x0007
#define                                        WAIT_FOR_RELEASE_ADDR   0x15bb
#define                                WAIT_THEN_SERVICE_TOUCH_XADDR   0x072ef3
#define                                 WAIT_THEN_SERVICE_TOUCH_PAGE   0x0007
#define                                 WAIT_THEN_SERVICE_TOUCH_ADDR   0x2ef3
// Variables for Kernel Extension Package: EtherWiFi
#define                                   ether_service_module_XADDR   0x8e12
#define                                         ether_response_XADDR   0x8e18
#define                                      ether_gui_message_XADDR   0x8e1c
#define                                          ether_command_XADDR   0x8e14
#define                                  ether_revector_module_XADDR   0x8e10
// Symbols for Kernel Extension Package: EtherWiFi
#define                                                    CAT_XADDR   0x0d0538
#define                                                     CAT_PAGE   0x000d
#define                                                     CAT_ADDR   0x0538
#define                                        ETHER_ADD_CHARS_XADDR   0x0d206a
#define                                         ETHER_ADD_CHARS_PAGE   0x000d
#define                                         ETHER_ADD_CHARS_ADDR   0x206a
#define                                         ETHER_ADD_DATA_XADDR   0x0d1e87
#define                                          ETHER_ADD_DATA_PAGE   0x000d
#define                                          ETHER_ADD_DATA_ADDR   0x1e87
#define                                         ETHER_ADD_LINE_XADDR   0x0d2094
#define                                          ETHER_ADD_LINE_PAGE   0x000d
#define                                          ETHER_ADD_LINE_ADDR   0x2094
#define                                        ETHER_ASCII_KEY_XADDR   0x0d1b4f
#define                                         ETHER_ASCII_KEY_PAGE   0x000d
#define                                         ETHER_ASCII_KEY_ADDR   0x1b4f
#define                                         ETHER_ASK_EMIT_XADDR   0x0d1b31
#define                                          ETHER_ASK_EMIT_PAGE   0x000d
#define                                          ETHER_ASK_EMIT_ADDR   0x1b31
#define                                          ETHER_ASK_KEY_XADDR   0x0d1b3b
#define                                           ETHER_ASK_KEY_PAGE   0x000d
#define                                           ETHER_ASK_KEY_ADDR   0x1b3b
#define                                   ETHER_AWAIT_RESPONSE_XADDR   0x0d1ca8
#define                                    ETHER_AWAIT_RESPONSE_PAGE   0x000d
#define                                    ETHER_AWAIT_RESPONSE_ADDR   0x1ca8
#define                                        ETHER_CHECK_GUI_XADDR   0x0d550f
#define                                         ETHER_CHECK_GUI_PAGE   0x000d
#define                                         ETHER_CHECK_GUI_ADDR   0x550f
#define                                   ETHER_CHECK_RESPONSE_XADDR   0x0d1cb5
#define                                    ETHER_CHECK_RESPONSE_PAGE   0x000d
#define                                    ETHER_CHECK_RESPONSE_ADDR   0x1cb5
#define                                  ETHER_COMMAND_MANAGER_XADDR   0x0d6067
#define                                   ETHER_COMMAND_MANAGER_PAGE   0x000d
#define                                   ETHER_COMMAND_MANAGER_ADDR   0x6067
#define                                          ETHER_CONNECT_XADDR   0x0d4831
#define                                           ETHER_CONNECT_PAGE   0x000d
#define                                           ETHER_CONNECT_ADDR   0x4831
#define                               ETHER_CONNECTION_MANAGER_XADDR   0x0d61c1
#define                                ETHER_CONNECTION_MANAGER_PAGE   0x000d
#define                                ETHER_CONNECTION_MANAGER_ADDR   0x61c1
#define                                   ETHER_CONNECT_STATUS_XADDR   0x0d1cce
#define                                    ETHER_CONNECT_STATUS_PAGE   0x000d
#define                                    ETHER_CONNECT_STATUS_ADDR   0x1cce
#define                                        ETHER_DHCP_NAME_XADDR   0x0d1151
#define                                         ETHER_DHCP_NAME_PAGE   0x000d
#define                                         ETHER_DHCP_NAME_ADDR   0x1151
#define                                       ETHER_DISCONNECT_XADDR   0x0d480b
#define                                        ETHER_DISCONNECT_PAGE   0x000d
#define                                        ETHER_DISCONNECT_ADDR   0x480b
#define                           ETHER_DISCONNECT_DURING_SEND_XADDR   0x0d1ce2
#define                            ETHER_DISCONNECT_DURING_SEND_PAGE   0x000d
#define                            ETHER_DISCONNECT_DURING_SEND_ADDR   0x1ce2
#define                                 ETHER_DISCONNECT_FLUSH_XADDR   0x0d481b
#define                                  ETHER_DISCONNECT_FLUSH_PAGE   0x000d
#define                                  ETHER_DISCONNECT_FLUSH_ADDR   0x481b
#define                                             ETHER_EMIT_XADDR   0x0d1b27
#define                                              ETHER_EMIT_PAGE   0x000d
#define                                              ETHER_EMIT_ADDR   0x1b27
#define                                       ETHER_ENCRYPTION_XADDR   0x0d3a85
#define                                        ETHER_ENCRYPTION_PAGE   0x000d
#define                                        ETHER_ENCRYPTION_ADDR   0x3a85
#define                                            ETHER_ERROR_XADDR   0x0d0e38
#define                                             ETHER_ERROR_PAGE   0x000d
#define                                             ETHER_ERROR_ADDR   0x0e38
#define                                      ETHER_ERROR_CLEAR_XADDR   0x0d0e42
#define                                       ETHER_ERROR_CLEAR_PAGE   0x000d
#define                                       ETHER_ERROR_CLEAR_ADDR   0x0e42
#define                                            ETHER_FLUSH_XADDR   0x0d1e77
#define                                             ETHER_FLUSH_PAGE   0x000d
#define                                             ETHER_FLUSH_ADDR   0x1e77
#define                                     ETHER_FLUSH_NBYTES_XADDR   0x0d1e41
#define                                      ETHER_FLUSH_NBYTES_PAGE   0x000d
#define                                      ETHER_FLUSH_NBYTES_ADDR   0x1e41
#define                                          ETHER_GATEWAY_XADDR   0x0d1101
#define                                           ETHER_GATEWAY_PAGE   0x000d
#define                                           ETHER_GATEWAY_ADDR   0x1101
#define                                   ETHER_GATEWAY_IP_PTR_XADDR   0x0d0d82
#define                                    ETHER_GATEWAY_IP_PTR_PAGE   0x000d
#define                                    ETHER_GATEWAY_IP_PTR_ADDR   0x0d82
#define                                        ETHER_GET_CHARS_XADDR   0x0d2071
#define                                         ETHER_GET_CHARS_PAGE   0x000d
#define                                         ETHER_GET_CHARS_ADDR   0x2071
#define                                         ETHER_GET_DATA_XADDR   0x0d1e8e
#define                                          ETHER_GET_DATA_PAGE   0x000d
#define                                          ETHER_GET_DATA_ADDR   0x1e8e
#define                                         ETHER_GET_LINE_XADDR   0x0d2078
#define                                          ETHER_GET_LINE_PAGE   0x000d
#define                                          ETHER_GET_LINE_ADDR   0x2078
#define                                            ETHER_INBUF_XADDR   0x0d0d90
#define                                             ETHER_INBUF_PAGE   0x000d
#define                                             ETHER_INBUF_ADDR   0x0d90
#define                                        ETHER_INBUFSIZE_XADDR   0x0d0dae
#define                                         ETHER_INBUFSIZE_PAGE   0x000d
#define                                         ETHER_INBUFSIZE_ADDR   0x0dae
#define                                             ETHER_INFO_XADDR   0x0d0d4c
#define                                              ETHER_INFO_PAGE   0x000d
#define                                              ETHER_INFO_ADDR   0x0d4c
#define                                        ETHER_INFO_INIT_XADDR   0x0d5ce6
#define                                         ETHER_INFO_INIT_PAGE   0x000d
#define                                         ETHER_INFO_INIT_ADDR   0x5ce6
#define                                             ETHER_INIT_XADDR   0x0d5f7e
#define                                              ETHER_INIT_PAGE   0x000d
#define                                              ETHER_INIT_ADDR   0x5f7e
#define                          ETHER_INTERNAL_WEBSERVER_PORT_XADDR   0x0d10d6
#define                           ETHER_INTERNAL_WEBSERVER_PORT_PAGE   0x000d
#define                           ETHER_INTERNAL_WEBSERVER_PORT_ADDR   0x10d6
#define                                   ETHER_IP_INFO_REPORT_XADDR   0x0d437c
#define                                    ETHER_IP_INFO_REPORT_PAGE   0x000d
#define                                    ETHER_IP_INFO_REPORT_ADDR   0x437c
#define                                  ETHER_IP_INFO_REQUEST_XADDR   0x0d436c
#define                                   ETHER_IP_INFO_REQUEST_PAGE   0x000d
#define                                   ETHER_IP_INFO_REQUEST_ADDR   0x436c
#define                                              ETHER_KEY_XADDR   0x0d1b45
#define                                               ETHER_KEY_PAGE   0x000d
#define                                               ETHER_KEY_ADDR   0x1b45
#define                                         ETHER_LOCAL_IP_XADDR   0x0d107b
#define                                          ETHER_LOCAL_IP_PAGE   0x000d
#define                                          ETHER_LOCAL_IP_ADDR   0x107b
#define                                       ETHER_LOCAL_PORT_XADDR   0x0d10ab
#define                                        ETHER_LOCAL_PORT_PAGE   0x000d
#define                                        ETHER_LOCAL_PORT_ADDR   0x10ab
#define                                          ETHER_MONITOR_XADDR   0x0d645d
#define                                           ETHER_MONITOR_PAGE   0x000d
#define                                           ETHER_MONITOR_ADDR   0x645d
#define                                        ETHER_MY_IP_PTR_XADDR   0x0d0d7b
#define                                         ETHER_MY_IP_PTR_PAGE   0x000d
#define                                         ETHER_MY_IP_PTR_ADDR   0x0d7b
#define                                      ETHER_NETMASK_PTR_XADDR   0x0d0d89
#define                                       ETHER_NETMASK_PTR_PAGE   0x000d
#define                                       ETHER_NETMASK_PTR_ADDR   0x0d89
#define                                           ETHER_OUTBUF_XADDR   0x0d0d9a
#define                                            ETHER_OUTBUF_PAGE   0x000d
#define                                            ETHER_OUTBUF_ADDR   0x0d9a
#define                                       ETHER_OUTBUFSIZE_XADDR   0x0d0da4
#define                                        ETHER_OUTBUFSIZE_PAGE   0x000d
#define                                        ETHER_OUTBUFSIZE_ADDR   0x0da4
#define                                       ETHER_OUTBUF_CAT_XADDR   0x0d1c42
#define                                        ETHER_OUTBUF_CAT_PAGE   0x000d
#define                                        ETHER_OUTBUF_CAT_ADDR   0x1c42
#define                       ETHER_PASSIVE_NON_WEB_CONNECTION_XADDR   0x0d1cd8
#define                        ETHER_PASSIVE_NON_WEB_CONNECTION_PAGE   0x000d
#define                        ETHER_PASSIVE_NON_WEB_CONNECTION_ADDR   0x1cd8
#define                                      ETHER_PING_REPORT_XADDR   0x0d3ff2
#define                                       ETHER_PING_REPORT_PAGE   0x000d
#define                                       ETHER_PING_REPORT_ADDR   0x3ff2
#define                                     ETHER_PING_REQUEST_XADDR   0x0d3fa4
#define                                      ETHER_PING_REQUEST_PAGE   0x000d
#define                                      ETHER_PING_REQUEST_ADDR   0x3fa4
#define                                ETHER_READY_FOR_COMMAND_XADDR   0x0d1c98
#define                                 ETHER_READY_FOR_COMMAND_PAGE   0x000d
#define                                 ETHER_READY_FOR_COMMAND_ADDR   0x1c98
#define                                    ETHER_REMOTE_IP_PTR_XADDR   0x0d1143
#define                                     ETHER_REMOTE_IP_PTR_PAGE   0x000d
#define                                     ETHER_REMOTE_IP_PTR_ADDR   0x1143
#define                                  ETHER_REMOTE_PORT_PTR_XADDR   0x0d114a
#define                                   ETHER_REMOTE_PORT_PTR_PAGE   0x000d
#define                                   ETHER_REMOTE_PORT_PTR_ADDR   0x114a
#define                                    ETHER_SEND_2BUFFERS_XADDR   0x0d2449
#define                                     ETHER_SEND_2BUFFERS_PAGE   0x000d
#define                                     ETHER_SEND_2BUFFERS_ADDR   0x2449
#define                                      ETHER_SEND_BUFFER_XADDR   0x0d23f9
#define                                       ETHER_SEND_BUFFER_PAGE   0x000d
#define                                       ETHER_SEND_BUFFER_ADDR   0x23f9
#define                                       ETHER_SEND_EMAIL_XADDR   0x0d5c1f
#define                                        ETHER_SEND_EMAIL_PAGE   0x000d
#define                                        ETHER_SEND_EMAIL_ADDR   0x5c1f
#define                                     ETHER_SEND_LBUFFER_XADDR   0x0d243c
#define                                      ETHER_SEND_LBUFFER_PAGE   0x000d
#define                                      ETHER_SEND_LBUFFER_ADDR   0x243c
#define                                  ETHER_SERIAL_REVECTOR_XADDR   0x0d6420
#define                                   ETHER_SERIAL_REVECTOR_PAGE   0x000d
#define                                   ETHER_SERIAL_REVECTOR_ADDR   0x6420
#define                                     ETHER_SERVICE_LOOP_XADDR   0x0d63c1
#define                                      ETHER_SERVICE_LOOP_PAGE   0x000d
#define                                      ETHER_SERVICE_LOOP_ADDR   0x63c1
#define                                            ETHER_SETUP_XADDR   0x0d5fad
#define                                             ETHER_SETUP_PAGE   0x000d
#define                                             ETHER_SETUP_ADDR   0x5fad
#define                                    ETHER_SETUP_DEFAULT_XADDR   0x0d6041
#define                                     ETHER_SETUP_DEFAULT_PAGE   0x000d
#define                                     ETHER_SETUP_DEFAULT_ADDR   0x6041
#define                                        ETHER_SET_INBUF_XADDR   0x0d0db8
#define                                         ETHER_SET_INBUF_PAGE   0x000d
#define                                         ETHER_SET_INBUF_ADDR   0x0db8
#define                                       ETHER_SET_OUTBUF_XADDR   0x0d0dce
#define                                        ETHER_SET_OUTBUF_PAGE   0x000d
#define                                        ETHER_SET_OUTBUF_ADDR   0x0dce
#define                                         ETHER_SHUTDOWN_XADDR   0x0d1c94
#define                                          ETHER_SHUTDOWN_PAGE   0x000d
#define                                          ETHER_SHUTDOWN_ADDR   0x1c94
#define                                       ETHER_TASK_SETUP_XADDR   0x0d63da
#define                                        ETHER_TASK_SETUP_PAGE   0x000d
#define                                        ETHER_TASK_SETUP_ADDR   0x63da
#define                                      ETHER_TCP_CONTROL_XADDR   0x0d119d
#define                                       ETHER_TCP_CONTROL_PAGE   0x000d
#define                                       ETHER_TCP_CONTROL_ADDR   0x119d
#define                                  ETHER_TELNET_PASSWORD_XADDR   0x0d1178
#define                                   ETHER_TELNET_PASSWORD_PAGE   0x000d
#define                                   ETHER_TELNET_PASSWORD_ADDR   0x1178
#define                                ETHER_TUNNEL_ENABLE_PTR_XADDR   0x0d0e53
#define                                 ETHER_TUNNEL_ENABLE_PTR_PAGE   0x000d
#define                                 ETHER_TUNNEL_ENABLE_PTR_ADDR   0x0e53
#define                                   ETHER_XPORT_DEFAULTS_XADDR   0x0d3c52
#define                                    ETHER_XPORT_DEFAULTS_PAGE   0x000d
#define                                    ETHER_XPORT_DEFAULTS_ADDR   0x3c52
#define                                     ETHER_XPORT_UPDATE_XADDR   0x0d3c62
#define                                      ETHER_XPORT_UPDATE_PAGE   0x000d
#define                                      ETHER_XPORT_UPDATE_ADDR   0x3c62
#define                                            E_ASCII_KEY_XADDR   0x0d1b8f
#define                                             E_ASCII_KEY_PAGE   0x000d
#define                                             E_ASCII_KEY_ADDR   0x1b8f
#define                                              E_ASK_KEY_XADDR   0x0d1b7b
#define                                               E_ASK_KEY_PAGE   0x000d
#define                                               E_ASK_KEY_ADDR   0x1b7b
#define                                                 E_EMIT_XADDR   0x0d1b71
#define                                                  E_EMIT_PAGE   0x000d
#define                                                  E_EMIT_ADDR   0x1b71
#define                                                  E_KEY_XADDR   0x0d1b85
#define                                                   E_KEY_PAGE   0x000d
#define                                                   E_KEY_ADDR   0x1b85
#define                                   HTTP_ADD_GUI_HANDLER_XADDR   0x0d4a0a
#define                                    HTTP_ADD_GUI_HANDLER_PAGE   0x000d
#define                                    HTTP_ADD_GUI_HANDLER_ADDR   0x4a0a
#define                                       HTTP_ADD_HANDLER_XADDR   0x0d49fa
#define                                        HTTP_ADD_HANDLER_PAGE   0x000d
#define                                        HTTP_ADD_HANDLER_ADDR   0x49fa
#define                                     HTTP_AUTOSERVE_PTR_XADDR   0x0d0e9c
#define                                      HTTP_AUTOSERVE_PTR_PAGE   0x000d
#define                                      HTTP_AUTOSERVE_PTR_ADDR   0x0e9c
#define                                   HTTP_DEFAULT_HANDLER_XADDR   0x0d5354
#define                                    HTTP_DEFAULT_HANDLER_PAGE   0x000d
#define                                    HTTP_DEFAULT_HANDLER_ADDR   0x5354
#define                               HTTP_DEFAULT_HANDLER_PTR_XADDR   0x0d0ea6
#define                                HTTP_DEFAULT_HANDLER_PTR_PAGE   0x000d
#define                                HTTP_DEFAULT_HANDLER_PTR_ADDR   0x0ea6
#define                                        HTTP_ENABLE_PTR_XADDR   0x0d0e4c
#define                                         HTTP_ENABLE_PTR_PAGE   0x000d
#define                                         HTTP_ENABLE_PTR_ADDR   0x0e4c
#define                                   HTTP_FIELDNAME_COUNT_XADDR   0x0d4a33
#define                                    HTTP_FIELDNAME_COUNT_PAGE   0x000d
#define                                    HTTP_FIELDNAME_COUNT_ADDR   0x4a33
#define                                     HTTP_FIELDNAME_PTR_XADDR   0x0d4a1a
#define                                      HTTP_FIELDNAME_PTR_PAGE   0x000d
#define                                      HTTP_FIELDNAME_PTR_ADDR   0x4a1a
#define                              HTTP_GET_TIMEOUT_MSEC_PTR_XADDR   0x0d0e72
#define                               HTTP_GET_TIMEOUT_MSEC_PTR_PAGE   0x000d
#define                               HTTP_GET_TIMEOUT_MSEC_PTR_ADDR   0x0e72
#define                                 HTTP_GUI_SEND_2BUFFERS_XADDR   0x0d4f19
#define                                  HTTP_GUI_SEND_2BUFFERS_PAGE   0x000d
#define                                  HTTP_GUI_SEND_2BUFFERS_ADDR   0x4f19
#define                                   HTTP_GUI_SEND_BUFFER_XADDR   0x0d4ec0
#define                                    HTTP_GUI_SEND_BUFFER_PAGE   0x000d
#define                                    HTTP_GUI_SEND_BUFFER_ADDR   0x4ec0
#define                                  HTTP_GUI_SEND_LBUFFER_XADDR   0x0d4f0c
#define                                   HTTP_GUI_SEND_LBUFFER_PAGE   0x000d
#define                                   HTTP_GUI_SEND_LBUFFER_ADDR   0x4f0c
#define                                          HTTP_IMAGEMAP_XADDR   0x0d4ba7
#define                                           HTTP_IMAGEMAP_PAGE   0x000d
#define                                           HTTP_IMAGEMAP_ADDR   0x4ba7
#define                                             HTTP_INBUF_XADDR   0x0d0de4
#define                                              HTTP_INBUF_PAGE   0x000d
#define                                              HTTP_INBUF_ADDR   0x0de4
#define                                         HTTP_INBUFSIZE_XADDR   0x0d0e02
#define                                          HTTP_INBUFSIZE_PAGE   0x000d
#define                                          HTTP_INBUFSIZE_ADDR   0x0e02
#define                                         HTTP_INDEX_PTR_XADDR   0x0d0e79
#define                                          HTTP_INDEX_PTR_PAGE   0x000d
#define                                          HTTP_INDEX_PTR_ADDR   0x0e79
#define                                HTTP_IS_AUTOSERVE_ARRAY_XADDR   0x0d0e80
#define                                 HTTP_IS_AUTOSERVE_ARRAY_PAGE   0x000d
#define                                 HTTP_IS_AUTOSERVE_ARRAY_ADDR   0x0e80
#define                                     HTTP_NUMBYTES_SENT_XADDR   0x0d0e5a
#define                                      HTTP_NUMBYTES_SENT_PAGE   0x000d
#define                                      HTTP_NUMBYTES_SENT_ADDR   0x0e5a
#define                                            HTTP_OUTBUF_XADDR   0x0d0dee
#define                                             HTTP_OUTBUF_PAGE   0x000d
#define                                             HTTP_OUTBUF_ADDR   0x0dee
#define                                        HTTP_OUTBUFSIZE_XADDR   0x0d0df8
#define                                         HTTP_OUTBUFSIZE_PAGE   0x000d
#define                                         HTTP_OUTBUFSIZE_ADDR   0x0df8
#define                                        HTTP_OUTBUF_CAT_XADDR   0x0d1c6b
#define                                         HTTP_OUTBUF_CAT_PAGE   0x000d
#define                                         HTTP_OUTBUF_CAT_ADDR   0x1c6b
#define                                         HTTP_PARSE_URL_XADDR   0x0d4d84
#define                                          HTTP_PARSE_URL_PAGE   0x000d
#define                                          HTTP_PARSE_URL_ADDR   0x4d84
#define                                     HTTP_PLUS_TO_SPACE_XADDR   0x0d4c5e
#define                                      HTTP_PLUS_TO_SPACE_PAGE   0x000d
#define                                      HTTP_PLUS_TO_SPACE_ADDR   0x4c5e
#define                                  HTTP_PUT_CONTENT_TYPE_XADDR   0x0d5229
#define                                   HTTP_PUT_CONTENT_TYPE_PAGE   0x000d
#define                                   HTTP_PUT_CONTENT_TYPE_ADDR   0x5229
#define                                        HTTP_PUT_HEADER_XADDR   0x0d51fb
#define                                         HTTP_PUT_HEADER_PAGE   0x000d
#define                                         HTTP_PUT_HEADER_ADDR   0x51fb
#define                                     HTTP_SEND_2BUFFERS_XADDR   0x0d4e70
#define                                      HTTP_SEND_2BUFFERS_PAGE   0x000d
#define                                      HTTP_SEND_2BUFFERS_ADDR   0x4e70
#define                                       HTTP_SEND_BUFFER_XADDR   0x0d4e4a
#define                                        HTTP_SEND_BUFFER_PAGE   0x000d
#define                                        HTTP_SEND_BUFFER_ADDR   0x4e4a
#define                                      HTTP_SEND_LBUFFER_XADDR   0x0d4e5a
#define                                       HTTP_SEND_LBUFFER_PAGE   0x000d
#define                                       HTTP_SEND_LBUFFER_ADDR   0x4e5a
#define                                            HTTP_SERVER_XADDR   0x0d5428
#define                                             HTTP_SERVER_PAGE   0x000d
#define                                             HTTP_SERVER_ADDR   0x5428
#define                                         HTTP_SET_INBUF_XADDR   0x0d0e0c
#define                                          HTTP_SET_INBUF_PAGE   0x000d
#define                                          HTTP_SET_INBUF_ADDR   0x0e0c
#define                                        HTTP_SET_OUTBUF_XADDR   0x0d0e22
#define                                         HTTP_SET_OUTBUF_PAGE   0x000d
#define                                         HTTP_SET_OUTBUF_ADDR   0x0e22
#define                                        HTTP_STATUS_PTR_XADDR   0x0d0e64
#define                                         HTTP_STATUS_PTR_PAGE   0x000d
#define                                         HTTP_STATUS_PTR_ADDR   0x0e64
#define                                  HTTP_TIMEOUT_MSEC_PTR_XADDR   0x0d0e6b
#define                                   HTTP_TIMEOUT_MSEC_PTR_PAGE   0x000d
#define                                   HTTP_TIMEOUT_MSEC_PTR_ADDR   0x0e6b
#define                                     HTTP_TO_NEXT_FIELD_XADDR   0x0d4b0e
#define                                      HTTP_TO_NEXT_FIELD_PAGE   0x000d
#define                                      HTTP_TO_NEXT_FIELD_ADDR   0x4b0e
#define                                          HTTP_UNESCAPE_XADDR   0x0d4c92
#define                                           HTTP_UNESCAPE_PAGE   0x000d
#define                                           HTTP_UNESCAPE_ADDR   0x4c92
#define                                    HTTP_URL_BASE_COUNT_XADDR   0x0d0ec1
#define                                     HTTP_URL_BASE_COUNT_PAGE   0x000d
#define                                     HTTP_URL_BASE_COUNT_ADDR   0x0ec1
#define                                    HTTP_URL_FULL_COUNT_XADDR   0x0d0eb7
#define                                     HTTP_URL_FULL_COUNT_PAGE   0x000d
#define                                     HTTP_URL_FULL_COUNT_ADDR   0x0eb7
#define                                           HTTP_URL_PTR_XADDR   0x0d0ead
#define                                            HTTP_URL_PTR_PAGE   0x000d
#define                                            HTTP_URL_PTR_ADDR   0x0ead
#define                                       HTTP_VALUE_COUNT_XADDR   0x0d4ab7
#define                                        HTTP_VALUE_COUNT_PAGE   0x000d
#define                                        HTTP_VALUE_COUNT_ADDR   0x4ab7
#define                                         HTTP_VALUE_PTR_XADDR   0x0d4aa4
#define                                          HTTP_VALUE_PTR_PAGE   0x000d
#define                                          HTTP_VALUE_PTR_ADDR   0x4aa4
#define                                             WIFI_CHECK_XADDR   0x0d0d65
#define                                              WIFI_CHECK_PAGE   0x000d
#define                                              WIFI_CHECK_ADDR   0x0d65
#define                                    WIFI_ENCRYPTION_KEY_XADDR   0x0d3b8a
#define                                     WIFI_ENCRYPTION_KEY_PAGE   0x000d
#define                                     WIFI_ENCRYPTION_KEY_ADDR   0x3b8a
#define                                         WIFI_INFO_INIT_XADDR   0x0d5f71
#define                                          WIFI_INFO_INIT_PAGE   0x000d
#define                                          WIFI_INFO_INIT_ADDR   0x5f71
#define                                              WIFI_INIT_XADDR   0x0d5fa0
#define                                               WIFI_INIT_PAGE   0x000d
#define                                               WIFI_INIT_ADDR   0x5fa0
#define                                            WIFI_MODULE_XADDR   0x0d0d33
#define                                             WIFI_MODULE_PAGE   0x000d
#define                                             WIFI_MODULE_ADDR   0x0d33
#define                                           WIFI_OPTIONS_XADDR   0x0d12b0
#define                                            WIFI_OPTIONS_PAGE   0x000d
#define                                            WIFI_OPTIONS_ADDR   0x12b0
#define                                          WIFI_SECURITY_XADDR   0x0d11f7
#define                                           WIFI_SECURITY_PAGE   0x000d
#define                                           WIFI_SECURITY_ADDR   0x11f7
#define                                             WIFI_SETUP_XADDR   0x0d6034
#define                                              WIFI_SETUP_PAGE   0x000d
#define                                              WIFI_SETUP_ADDR   0x6034
#define                                     WIFI_SETUP_DEFAULT_XADDR   0x0d605a
#define                                      WIFI_SETUP_DEFAULT_PAGE   0x000d
#define                                      WIFI_SETUP_DEFAULT_ADDR   0x605a
#define                                              WIFI_SSID_XADDR   0x0d128b
#define                                               WIFI_SSID_PAGE   0x000d
#define                                               WIFI_SSID_ADDR   0x128b
#define                                        WIFI_TASK_SETUP_XADDR   0x0d6413
#define                                         WIFI_TASK_SETUP_PAGE   0x000d
#define                                         WIFI_TASK_SETUP_ADDR   0x6413

// Beginning C Header file for package: EtherWiFi

extern _forth  void Cat (xaddr countedLStrAddr, uint maxChars, xaddr strToAdd, int cntToAdd, uint eol);

#define	WIFI_NO_SECURITY		  00 // used to turn off any security/authentication option
// the following are passed as the pairwise_encrypt_method to wifi_security routine:
#define	WIFI_WEP64_PAIR_ENCRYPT	  01
#define	WIFI_WEP128_PAIR_ENCRYPT  02
#define	WIFI_TKIP_PAIR_ENCRYPT	  03
#define	WIFI_CCMP_PAIR_ENCRYPT	  04
// the following are passed as the suite_method to wifi_security routine:
#define	WIFI_WEP_SUITE			  01
#define	WIFI_WPA_SUITE			  02
#define	WIFI_WPA2_SUITE			  03
// the following are passed as the group_encrypt_method to wifi_security routine:
#define	WIFI_WEP_GROUP_ENCRYPT	  01
#define	WIFI_TKIP_GROUP_ENCRYPT	  03
#define	WIFI_CCMP_GROUP_ENCRYPT	  04


_at(ether_revector_module_XADDR) extern  int ether_revector_module;

_at(ether_service_module_XADDR) extern  int ether_service_module;

_at(ether_command_XADDR) extern  ulong ether_command;

_at(ether_response_XADDR) extern  ulong ether_response;

_at(ether_gui_message_XADDR) extern  ulong ether_gui_message;

extern _forth  void WiFi_Module ( int modulenum );

extern _forth  xaddr Ether_Info ( int modulenum );

extern _forth  int WiFi_Check ( int modulenum );

extern _forth  xaddr Ether_My_IP_Ptr ( int modulenum );

extern _forth  xaddr Ether_Gateway_IP_Ptr ( int modulenum );

extern _forth  xaddr Ether_Netmask_Ptr ( int modulenum );

extern _forth  xaddr Ether_Inbuf ( int modulenum );

extern _forth  xaddr Ether_Outbuf ( int modulenum );

extern _forth  uint Ether_Outbufsize ( int modulenum );

extern _forth  uint Ether_Inbufsize ( int modulenum );

extern _forth  void Ether_Set_Inbuf ( xaddr bufbase, int maxnumbytes, int modulenum );

extern _forth  void Ether_Set_Outbuf ( xaddr xbufbase, int maxnumbytes, int modulenum );

extern _forth  xaddr HTTP_Inbuf ( int modulenum );

extern _forth  xaddr HTTP_Outbuf ( int modulenum );

extern _forth  uint HTTP_Outbufsize ( int modulenum );

extern _forth  uint HTTP_Inbufsize ( int modulenum );

extern _forth  void HTTP_Set_Inbuf ( xaddr xbufbase, int maxnumbytes, int modulenum );

extern _forth  void HTTP_Set_Outbuf ( xaddr bufbase, int maxnumbytes, int modulenum );

extern _forth  uint Ether_Error ( int modulenum );

extern _forth  void Ether_Error_Clear ( int modulenum );

extern _forth  xaddr HTTP_Enable_Ptr ( int modulenum );

extern _forth  xaddr Ether_Tunnel_Enable_Ptr ( int modulenum );

extern _forth  uint HTTP_Numbytes_Sent ( int modulenum );

extern _forth  xaddr HTTP_Status_Ptr ( int modulenum );

extern _forth  xaddr HTTP_Timeout_Msec_Ptr ( int modulenum );

extern _forth  xaddr HTTP_Get_Timeout_Msec_Ptr ( int modulenum );

extern _forth  xaddr HTTP_Index_Ptr ( int modulenum );

extern _forth  void HTTP_Is_Autoserve_Array ( xaddr xarraybase, int numrows, int modulenum );

extern _forth  xaddr HTTP_Autoserve_Ptr ( int modulenum );

extern _forth  xaddr HTTP_Default_Handler_Ptr ( int modulenum );

extern _forth  xaddr HTTP_URL_Ptr ( int modulenum );

extern _forth  int HTTP_URL_Full_Count ( int modulenum );

extern _forth  int HTTP_URL_Base_Count ( int modulenum );

extern _forth  void Ether_Local_IP ( char ip1, char ip2, char ip3, char ip4, int modulenum );

extern _forth  void Ether_Local_Port ( int portnum, int modulenum );

extern _forth  void Ether_Internal_Webserver_Port ( int portnum, int modulenum );

extern _forth  void Ether_Gateway ( char ip1,char ip2,char ip3,char ip4, int subnet_bits, int modulenum );

extern _forth  xaddr Ether_Remote_IP_Ptr ( int modulenum );

extern _forth  xaddr Ether_Remote_Port_Ptr ( int modulenum );

extern _forth  void Ether_DHCP_Name ( xaddr xname_string, int name_cnt, int modulenum );

extern _forth  void Ether_Telnet_Password ( xaddr xpassword_string, int password_cnt, int modulenum );

extern _forth  void Ether_TCP_Control ( char keepalive_sec, char discon_minutes, int send_imm_chars, char flushmode, char packing, int modulenum );

extern _forth  void WiFi_Security ( int authenticate_flag, int suite_method, int pairwise_encrypt_method,	int group_encrypt_method, int key_length, int passphrase_flag, int modulenum );

extern _forth  void WiFi_SSID ( xaddr ssid_buffer_xbase, int count, int modulenum );

extern _forth  void WiFi_Options ( int tx_power_level, int tx_power_manager_flag, int tx_rate, int tx_auto_rate_flag, int adhoc_flag, int adhoc_chan, int modulenum );

extern _forth  void Ether_Emit ( uchar character,  int modulenum );

extern _forth  int Ether_Ask_Emit ( int modulenum );

extern _forth  int Ether_Ask_Key ( int modulenum );

extern _forth  uchar Ether_Key ( int modulenum );

extern _forth  uchar Ether_ASCII_Key ( int modulenum );

extern _forth  void E_Emit ( uchar character );

extern _forth  int E_Ask_Key ( void );

extern _forth  uchar E_Key ( void );

extern _forth  uchar E_ASCII_Key ( void );

extern _forth  void Ether_Outbuf_Cat ( xaddr xstring, uint count, int modulenum );

extern _forth  void HTTP_Outbuf_Cat ( xaddr xstring, uint count, int modulenum );

extern _forth  void Ether_Shutdown ( int modulenum );

extern _forth  int Ether_Ready_For_Command ( int modulenum );

extern _forth  ulong Ether_Await_Response ( int modulenum );

extern _forth  ulong Ether_Check_Response ( int modulenum );

extern _forth  int Ether_Connect_Status ( int modulenum );

extern _forth  int Ether_Passive_Non_Web_Connection ( int modulenum );

extern _forth  int Ether_Disconnect_During_Send ( int modulenum );

extern _forth  void Ether_Flush_NBytes ( uint maxbytes, uint timeout_msec, int modulenum );

extern _forth  void Ether_Flush ( int modulenum );

extern _forth  void Ether_Add_Data ( xaddr xlbuffer, uint maxbytes, uint timeout_msec, int modulenum );

extern _forth  void Ether_Get_Data ( xaddr xlbuffer, uint maxbytes, uint timeout_msec, int modulenum );

extern _forth  void Ether_Add_Chars ( xaddr xlbuffer, uint maxbytes, uint maxlines, char eol, int discard_alt_eol, int discard_msbit_set, uint timeout_msec, int modulenum );

extern _forth  void Ether_Get_Chars ( xaddr xlbuffer, uint maxbytes, uint maxlines, char eol, int discard_alt_eol, int discard_msbit_set, uint timeout_msec, int modulenum );

extern _forth  void Ether_Get_Line ( xaddr xlbuffer, uint maxbytes, char eol, int discard_alt_eol, int discard_msbit_set, uint timeout_msec, int modulenum );

extern _forth  void Ether_Add_Line ( xaddr xlbuffer, uint maxbytes, char eol, int discard_alt_eol, int discard_msbit_set, uint timeout_msec, int modulenum );

extern _forth  void Ether_Send_Buffer ( xaddr xbuffer, uint count, uint timeout_msec, int modulenum );

extern _forth  void Ether_Send_LBuffer ( xaddr xlbuffer, uint timeout_msec, int modulenum );

extern _forth  void Ether_Send_2Buffers ( xaddr xbuffer1, uint count1, xaddr xbuffer2, uint count2, uint timeout_msec, int modulenum );

extern _forth  int Ether_Encryption ( xaddr key_buffer_xbase, int num_key_bytes, int modulenum );

extern _forth  int WiFi_Encryption_Key ( xaddr key_buffer_xbase, int num_key_bytes, int modulenum );

extern _forth  void Ether_XPort_Defaults ( int modulenum );

extern _forth  void Ether_XPort_Update ( int modulenum );

extern _forth  void Ether_Ping_Request ( char ip1, char ip2, char ip3, char ip4, int modulenum );

extern _forth  void Ether_Ping_Report ( char ip1, char ip2, char ip3, char ip4, int modulenum );

extern _forth  void Ether_IP_Info_Request ( int modulenum );

extern _forth  void Ether_IP_Info_Report ( int modulenum );

extern _forth  void Ether_Disconnect ( int modulenum );

extern _forth  void Ether_Disconnect_Flush ( int modulenum );

extern _forth  void Ether_Connect ( char ip1, char ip2, char ip3, char ip4, int port, int modulenum );

extern _forth  int HTTP_Add_Handler ( xaddr url_xstring, int url_count, xaddr (*handler_ptr)(void), int modulenum );

extern _forth  int HTTP_Add_GUI_Handler ( xaddr url_xstring, int url_count, xaddr (*handler_ptr)(void), int modulenum );

extern _forth  xaddr HTTP_Fieldname_Ptr ( int modulenum );

extern _forth  int HTTP_Fieldname_Count ( int modulenum );

extern _forth  xaddr HTTP_Value_Ptr ( int modulenum );

extern _forth  int HTTP_Value_Count ( int modulenum );

extern _forth  int HTTP_To_Next_Field ( int modulenum );

extern _forth  TWO_INTS HTTP_Imagemap ( int modulenum );

extern _forth  void HTTP_Plus_To_Space ( xaddr xstring, int count );

extern _forth  int HTTP_Unescape ( xaddr xstring, int count );

extern _forth  void HTTP_Parse_URL ( xaddr xstring, int count, int modulenum );

extern _forth  uint HTTP_Send_Buffer ( xaddr xbuffer, uint count, int modulenum );

extern _forth  uint HTTP_Send_LBuffer ( xaddr xlbuffer, int modulenum );

extern _forth  uint HTTP_Send_2Buffers ( xaddr xbuffer1, uint count1, xaddr xbuffer2, uint count2,							int modulenum );

extern _forth  void HTTP_GUI_Send_Buffer ( xaddr xbuffer, uint count, int modulenum );

extern _forth  void HTTP_GUI_Send_LBuffer ( xaddr xlbuffer, int modulenum );

extern _forth  void HTTP_GUI_Send_2Buffers ( xaddr xbuffer1, uint count1, xaddr xbuffer2, uint count2, int modulenum );

#define HTTP_TEXT_HTML_CONTENT		-1	// text/html  (default)
#define HTTP_TEXT_PLAIN_CONTENT		0	// text/plain
#define HTTP_IMAGE_BITMAP_CONTENT	1	// image/bmp
#define HTTP_IMAGE_PNG_CONTENT		2	// image/png
#define HTTP_IMAGE_GIF_CONTENT		3	// image/gif
#define HTTP_IMAGE_JPEG_CONTENT		4	// image/jpeg
#define HTTP_BINARY_DATA_CONTENT	5	// application/octet-stream

#define ETHER_BUFSIZE_DEFAULT 510	// allotted buffer is 512, leaving room for 2byte lcount
#define HTTP_INBUFSIZE_DEFAULT 254	// allotted buffer is 256, leaving room for 2byte lcount
#define HTTP_OUTBUFSIZE_DEFAULT 1022 // allotted buf= 1024, leaving room for 2byte lcount
#define HTTP_AUTOSERVE_DEFAULT_ROWS 32	// default #rows in autoserve array, used by setup

#define  ETHER_MIN_BUFFER_SIZE 320 // enforced by ether_init for ether_inbuf, ether_outbuf


extern _forth  void HTTP_Put_Header ( xaddr xlbuffer, uint bufsize );

extern _forth  void HTTP_Put_Content_Type ( xaddr xlbuffer, uint bufsize, int dynamic, int content_type );

extern _forth  void HTTP_Default_Handler ( int modulenum );

extern _forth  void HTTP_Server ( int modulenum );

extern _forth  int Ether_Check_GUI ( int modulenum );

extern _forth  void Ether_Send_Email ( xaddr xemail_body,uint bodycnt,xaddr xhost,int hostcnt, xaddr xsender,int sendercnt,xaddr xrcvr, int rcvrcnt,xaddr xscratchbuf, char dest_ip1,char ip2,char ip3,char ip4,int destport,uint timeout_ms,int module);

extern _forth  int Ether_Info_Init ( xaddr xinfo,xaddr xautoserve,int numrows,xaddr xbuffer_area_base, xaddr xcmdmail,xaddr xresponsemail,xaddr xguimail,uint etherinbufsize, uint etheroutbufsize,uint httpinbufsize,uint httpoutbufsize,int modulenum);

extern _forth  int WiFi_Info_Init ( xaddr xinfo,xaddr xautoserve,int numrows,xaddr xbuffer_area_base, xaddr xcmdmail,xaddr xresponsemail,xaddr xguimail,uint etherinbufsize, uint etheroutbufsize,uint httpinbufsize,uint httpoutbufsize,int modulenum);

extern _forth  uint Ether_Init ( xaddr xinfo,xaddr xautoserve,int numrows,xaddr xbuffer_area_base, xaddr xcmdmail,xaddr xresponsemail,xaddr xguimail,uint etherinbufsize, uint etheroutbufsize,uint httpinbufsize,uint httpoutbufsize,int modulenum);

extern _forth  uint WiFi_Init ( xaddr xinfo,xaddr xautoserve,int numrows,xaddr xbuffer_area_base, xaddr xcmdmail,xaddr xresponsemail,xaddr xguimail,uint etherinbufsize, uint etheroutbufsize,uint httpinbufsize,uint httpoutbufsize,int modulenum);

extern _forth  uint Ether_Setup ( xaddr xbuffer_area_base, addr mailbox_base, int modulenum );

extern _forth  uint WiFi_Setup ( xaddr xbuffer_area_base, addr mailbox_base, int modulenum );

extern _forth  uint Ether_Setup_Default ( int modulenum );

extern _forth  uint WiFi_Setup_Default ( int modulenum );

extern _forth  void Ether_Command_Manager ( int modulenum );

extern _forth  void Ether_Connection_Manager ( int modulenum );

extern _forth  void Ether_Service_Loop ( void );

extern _forth  void Ether_Task_Setup ( TASK* task_base, int modulenum );

extern _forth  void WiFi_Task_Setup ( TASK* task_base, int modulenum );

extern _forth  void Ether_Serial_Revector ( void );

extern _forth  void Ether_Monitor ( void );

// End of C Header file for package: EtherWiFi

// Beginning C Header file for package: GUI_Toolkit_QSC
#define USING_QSC -1
// GUI Tools-- These #defines provide an interface between the GUI Toolkit
// and the programmer.  Information can be found in the GUI Toolkit manual.

#include <mosaic/gui_tk/to_large.h>

#ifndef __QED_GUI_TOOLS__
#define __QED_GUI_TOOLS__

#define __QED_GUI_TOOLS_VERSION__ 1.7

#define TVARS &tvars, 0

#define DRAW_MASK (GRAPHICS_MASK | DRAW_TEXTONLY_ACTION |\
ERASE_TEXTONLY_ACTION)
// BEGIN Macros

// Builds a button from the given parameters.   The text defined
// in quotes should also be on the page specified as GUI_STRINGS_PAGE
// (or in common RAM).  That shouldn't be too much of a problem since
// the strings are copied to each page anyway.


// the following are useful to transform a 32-bit xaddr into separate 16-bit addr, page
#ifndef XADDR_TO_ADDR
#define XADDR_TO_ADDR(xaddress)    ((uint) (0xFFFF & (xaddress)))
#define XADDR_TO_PAGE(xaddress)    ((int) (0xFF & ((xaddress)>>16)))

#endif  //   XADDR_TO_ADDR

// the following is useful to transform a separate 16-bit addr, page into a 32-bit xaddress
#ifndef TO_XADDR
#define TO_XADDR(address,page)     ((xaddr) (((page)<<16)+ (0xFFFF & (address))))

#endif  //   TO_XADDR


#define BLANKBUTTON( flags, draw_graphic,\
release_graphic, press_graphic, press_action,\
release_action, label1, label2, label3, label4, buttonname )\
BUTTON buttonname##_struct_={\
(flags)|C_STYLE_TEXT_FLAG,\
TO_XADDR((DO_GRAPHIC_ADDR),(DO_GRAPHIC_PAGE)),\
draw_graphic,\
release_graphic,\
press_graphic,\
press_action,\
release_action,\
(label1),\
(label2),\
(label3),\
(label4) \
}; BUTTON * buttonname=&buttonname##_struct_


// Builds a graphical button that uses direct screen I/O to handle touchscreen
// presses and releases.  Buttonname is that of the button being
// created.  Flags referes to the configuration flags for the new button.
// Draw_graphic, release_graphic, and press_graphic are pointers to the
// respective graphics.  These are usually generated by pcx2qed, a pc utility
// for generating images from pcx graphics files.  Each of these three graphics
// MUST be defined.  The func_addr is the action to be executed upon press,
// release, or both depending on which configuration flags are set.  The Labels
// are displayed inside the button if the DRAW_TEXT_FLAG is set.

#define FASTBUTTON_FLAGS \
( DRAW_GRAPHIC_FLAG |\
RELEASE_GRAPHIC_FLAG |\
DIR_RELEASE_GRAPHIC_FLAG |\
PRESS_GRAPHIC_FLAG |\
DIR_PRESS_GRAPHIC_FLAG |\
C_STYLE_TEXT_FLAG )

#define FASTBUTTON( flags,\
draw_graphic,\
release_graphic,\
press_graphic,\
action, label1, label2, label3, label4, buttonname )\
BUTTON buttonname##_struct_={\
(flags) | FASTBUTTON_FLAGS,\
TO_XADDR((DO_GRAPHIC_ADDR),(DO_GRAPHIC_PAGE)),\
draw_graphic,\
release_graphic,\
press_graphic,\
action,\
action,\
(label1),\
(label2),\
(label3),\
(label4) \
}; BUTTON * buttonname=&buttonname##_struct_



// Builds a graphical button that uses the graphics_garray to handle graphic
// presses and releases.  Buttonname is the that of the button being
// created.  Flags referes to the configuration flags for the new button.
// Draw_graphic, release_graphic, and press_graphic are pointers to the
// respective graphics.  These are usually generated by pcx2qed, a pc utility
// for generating images from pcx graphics files.  Each of these three graphics
// MUST be defined.  The func_addr is the action to be executed upon press,
// release, or both depending on which configuration flags are set.  The Labels
// are displayed inside the button if the DRAW_TEXT_FLAG is set.

#define NORMBUTTON_FLAGS \
( DRAW_GRAPHIC_FLAG |\
RELEASE_GRAPHIC_FLAG |\
PRESS_GRAPHIC_FLAG |\
C_STYLE_TEXT_FLAG )


#define NORMBUTTON( flags,\
draw_graphic,\
release_graphic,\
press_graphic,\
action, label1, label2, label3, label4, buttonname )\
BUTTON buttonname##_struct_={\
(flags) | NORMBUTTON_FLAGS,\
TO_XADDR((DO_GRAPHIC_ADDR),(DO_GRAPHIC_PAGE)),\
draw_graphic,\
release_graphic,\
press_graphic,\
action,\
action,\
(label1),\
(label2),\
(label3),\
(label4) \
}; BUTTON * buttonname=&buttonname##_struct_


// Menu building macros start here

#define BUTTON_WIDTH    8
#define BUTTON_HEIGHT   32
#define BUTTON_ROWS     4

#if USING_QSC

// this macro slightly differs from the one defined for the paneltouch
#define COLROW_TO_BUTTON( col,row )\
(((col)/BUTTON_WIDTH)*BUTTON_ROWS\
+((row)/BUTTON_HEIGHT)+1)

#else

// this macro slightly differs from the one defined for the Qscreen
#define COLROW_TO_BUTTON( col,row )\
(((col)/BUTTON_WIDTH)*BUTTON_ROWS\
+((row)/BUTTON_HEIGHT))
#endif

#define NEW_MENU MENU_ENTRY


#define SWAP_ADDR_AND_PAGE( address, page ) page, address


// Inserts a graphic into the current menu to be displayed at the screen
// offset of col,row.

#define ADD_GRAPHIC( col, row, action_mask, graphic_obj )\
{ row,\
col,\
(xaddr) graphic_obj,\
TO_XADDR(DO_GRAPHIC_ADDR,DO_GRAPHIC_PAGE),\
action_mask,\
BUTTON_NONLOCAL\
}

// Inserts a button into the current menu to be displayed at the screen
// offset of col,row and the keymap offset (button number) n.

#define ADD_BUTTON( n, col, row, action_mask, button_obj )\
{ row,\
col,\
&button_obj##_struct_,\
TO_XADDR(DO_BUTTON_ADDR,DO_BUTTON_PAGE),\
action_mask,\
n\
}

// Inserts a button into the current menu to be displayed at the screen
// offset of col,row.  The location on the touchscreen is computed
// automatically based on the col,row given.

#define ADD_TOUCH_BUTTON( col, row, action_mask, button_obj )\
{ row,\
col,\
&button_obj##_struct_,\
TO_XADDR(DO_BUTTON_ADDR,DO_BUTTON_PAGE),\
action_mask,\
COLROW_TO_BUTTON( col,row )\
}


// To be placed at the end of a menu to create the Forth array parameter
// field for the C array defined earlier.

//{ { (char *) &(arrayname##_m.xhandle.sixteen_bit.page16),\

#define BUILD_MENU( arrayname, num_elements)\
MENU arrayname##_menu_pf =\
{ { (char *) &(arrayname##_menu_pf.xhandle),\
0,\
sizeof( MENU_ENTRY ),\
1,\
num_elements,\
0,\
0,\
0 },\
(CFORTH_ARRAY *) arrayname\
}; MENU * arrayname##_menu=&arrayname##_menu_pf


// End Macros

#endif      // __QED_GUI_TOOLS__

#include <mosaic/gui_tk/fr_large.h>

// This is the header file for the GUI Software Toolkit.  JLW 4/14/1999

#include <mosaic/gui_tk/to_large.h>

#ifndef __QED_GUI_LIB__
#define __QED_GUI_LIB__

#define __QED_GUI_LIB_VERSION__ 1.7

// Additional type definitions
typedef int     boolean;
// typedef int     addr; // defined in types.h
// typedef int     page;

typedef struct {
    xaddr display_heap_top;         // The top of the display heap being used
    xaddr display_heap_bottom;      // The bottom of the display heap being used
    uint background_fill;           // The contents of this variable are filled
                                    // into the display graphics array when
                                    // clear.graphics is called.  T

    FORTH_ARRAY graphics_garray;    // We need an array for the graphics system
                                    // to use.  This array will be used by the
                                    // graphics calls in the menu system.  It
                                    // may be used by the application code also.

    xaddr display_resource;         // This resource variable manages access to
                                    // the graphics array and hardware.  This
                                    // variable is initialized by
                                    // init.dualmode.display

    uint gr_home_addr;              // Holds the address inside the display
                                    // where the graphics area begins
    uint text_home_addr;            // Holds the address inside the display
                                    // where the text area begins

    uint graphic_rows;              // The number of pixels lines on the display
    uint graphic_cols;              // The number of byte columns on the display
                                    // This depends on the setting of the hard-
                                    // ware Mode A pin on the TC6963 controller
                                    // chip. Not all LCDs bring this pin out,
                                    // but on the standard 240x128 display, it
                                    // is available
                                    // and may be set for either 6 or 8
                                    // pixels/byte.
                                    // This would cause +graphic_cols to have a
                                    // value of either 40 or 30 respectively.

    uint text_rows;                 // The number of text lines on the display
    uint text_cols;                 // The number of text columns

// Menu object globals:

    FORTH_ARRAY keymap_array;
        // The following are provided as an easy means for people to access
        // information about buttons being pressed
    uint current_row;                // The current row of the button pressed
    uint current_col;                // The current col of the button pressed

    uint current_keynum;             // The key index  of the button pressed
    xaddr current_button;            // the xpfa of the button that has just been
                                     // pressed.
#if USING_QSC
// Touchscreen globals:
    uint last_read_time;             // the last time the touchscreen was read
    uint raw_y_coord;                // current uncalibrated y coordinate
    uint raw_x_coord;                // current uncalibrated x coordinate
    uint cal_y_coord;                // current calibrated y coordinate
    uint cal_x_coord;                // current calibrated x coordinate
#endif
// Menu manager globals:
    uint repeat_delay;               // delay time before repeating in TS counts
    uint repeat_period;              // delay between repeat cycles in TS counts
} GUI_VARS;



typedef struct {                // Standard buttons will use this structure
  int flags;                    // the bitmaped flags used by the handler
                                // see above for description


  xaddr graphic_handler_xcfa;   // the xcfa to be EXECUTEd for the graphics
                                // this handler is required to process
                                // the stack picture that will be left for
                                // a graphic object.  It must be a forth
                                // and will be expected to process the the
                                // graphic class of commands.

  xaddr draw_graphic;           // the xpfa of the graphic shown on draw
  xaddr release_graphic;        // the xpfa of the graphic shown on release
  xaddr press_graphic;          // the xpfa of the graphic shown on press


  //page press_handler_page;
  void (*press_handler) ( );    // the xcfa of user code to run when on pressed

  //page release_handler_page;
  void (*release_handler) ( );  // the xcfa of user code to run when on released

                                // The above 2 xcfas may be either C or Forth
                                // given that they do not accept or return
                                // any values.  If there is a need to pass
                                // values  in or out, then global variables must
                                // be used.

        // Now, we include an optional 4 lines text that may be used.
        // These strings are expected to be forth style strings.
        // if this is a problem, then the code will be changed to accomodate
        // C style strings instead.

  char * label4;                 // line 4 text inside button (0-8 characters)
//  page label4_page;
//  char * label4;

  char * label3;                 // line 3 text inside button (0-8 characters)
//  page label3_page;
//  char * label3;

  char * label2;                 // line 2 text inside button (0-8 characters)
//  page label2_page;
//  char * label2;

  char * label1;                 // line 1 text inside button (0-8 characters)
//  page label1_page;
//  char * label4;

} BUTTON;

typedef struct { // Make a new type of structure
  int row;                      // The relative col number for the item
  int col;                      // The relative row number for the item

  BUTTON * obj_xaddr;
  //page object_page;
  //void * object;

  xaddr obj_handler;            // the xcfa of the code that handles the object

// Objects below here are not to be copied into the keymap index array
  uint action_mask;             // A mask to configure which actions may be
                                // passed through to the menu item
  uint button;                  // The relative index for button referencing
                                // +button# must correlate to the graphic
                                // location of the item for touchscreens.
                                // Otherwise, it can simply be used to specify
                                // what element in the keymap array will contain
                                // the item.
} MENU_ENTRY;


typedef struct {
  //page array_ptr_page;
  //char * array_ptr_addr;
  char * array_ptr;
  uint  pfa_currentHeap;
  uint   pfa_bytesPerElement;
  uint   pfa_numdimensions;
  uint   pfa_numCols;
  uint   pfa_numRows;
  uint   pfa_limit2;  // limit2 and limit3 are not used in 2D
  uint   pfa_limit3;  // array, but they must be allocated!
  } CFORTH_ARRAY ;

typedef struct {
  CFORTH_ARRAY arraypf;          // The array parameter field
  CFORTH_ARRAY * xhandle;
  //EXTENDED_ADDR xhandle;
//  page array_page;              // The pointer to the page of the FORTH_ARRAY
//  char * array_addr;            // The pointer to the FORTH_ARRAY
  } FORTH_CONST_ARRAY;

typedef FORTH_CONST_ARRAY MENU;

// Begin Font Stuff
// This is the font structure.  It binds 8 graphic objects into a
// font.  Each graphic object, called a tablet, represents 16 characters.
// Dividing this up makes the shape of the graphics a bit more manageable.
typedef struct {
    xaddr tablet0;
    xaddr tablet1;
    xaddr tablet2;
    xaddr tablet3;
    xaddr tablet4;
    xaddr tablet5;
    xaddr tablet6;
    xaddr tablet7;
    } FONT;

// This macro accepts TVARS and dereferences out the garray from it.
// It is better not to do that in the actual function since so that
// experts may use the low level call to render into an offscreen
// array.  This macro assumes that you want to draw into the onscreen
// GUI buffer.  The other thing this macro does is mark the string as
// a null term string so that Render_Font will know it is coming from C.

#define QUICK_RENDER_FONT(strAddr, column, row, font)\
   (Render_Font(strAddr, (THIS_PAGE+0xFF00), column, row, &tvars, 0, font, (THIS_PAGE)))

// This macro is quite similar to the above, but it must use TVARS since
// it simply direct renders to the LCD.
#define QUICK_DIRECT_RENDER_FONT(strAddr, column, row, font)\
    (Direct_Render_Font(strAddr, (THIS_PAGE+0xFF00), column, row, &tvars, 0, font, (THIS_PAGE)))

// End Font stuff



// ****Automatically generated by JLW forth to C awk script ver 5/5
// This file contains the constants that are defined in a forth program.
// This file was generated on Thu May 06 00:52:36 PDT 1999 by wadejer
// on the machine: circe.procyon.com


// Display configuration constants
#define GRAPHICS_DATA_ADDR                      0x80A0
#define GRAPHICS_CMD_ADDR                       0x80A2
#define AWSET_CMD                               0x00B0
#define AWRESET_CMD                             0x00B2
#define SET_TX_HOME_CMD                         0x0040
#define SET_TX_AREA_CMD                         0x0041
#define SET_GR_HOME_CMD                         0x0042
#define SET_GR_AREA_CMD                         0x0043
#define MODE_CMD                                0x0080
#define DISPLAY_MODE_CMD                        0x0090
#define CURSOR_BLINK                            0x0001
#define CURSOR_ON                               0x0002
#define TEXT_MODE                               0x0004
#define GRAPHICS_MODE                           0x0008
#define LCD_TEXT_ADDR                           0x0000
#define LCD_GRAPHIC_ADDR                        0x0280
#define LINES_PER_CHAR                            0008
#define GRAPHICS_COLUMNS                          0030
#define GRAPHICS_ROWS                             0128
#define TEXT_COLUMNS                              0040
#define TEXT_ROWS                                 0016
#define DISPLAY_HEAP_TOP                        0x0F46A0l
#define DISPLAY_HEAP_BOTTOM                     0x0F3000l
#define DEF_BACKGROUND_FILL                     0x0000

// Graphic Objects Constants
#define GRAPHICS_MASK                           0x001F
#define DRAW_ACTION                             0x0001
#define DIR_DRAW_ACTION                         0x0002
#define REDRAW_ACTION                           0x0004
#define ERASE_ACTION                            0x0008
#define DIR_ERASE_ACTION                        0x0010

// Button Constants
#define BUTTON_MASK                             0x03E0
#define PRESS_REPEAT_ACTION                     0x0020
#define PRESS_ACTION                            0x0040
#define REL_ACTION                              0x0080
#define DRAW_TEXTONLY_ACTION                    0x0100
#define ERASE_TEXTONLY_ACTION                   0x0200

// Button Flags
#define DRAW_GRAPHIC_FLAG                       0x0001
#define RELEASE_GRAPHIC_FLAG                    0x0002
#define PRESS_GRAPHIC_FLAG                      0x0004
#define DIR_DRAW_GRAPHIC_FLAG                   0x0008
#define DIR_RELEASE_GRAPHIC_FLAG                0x0010
#define DIR_PRESS_GRAPHIC_FLAG                  0x0020
#define DRAW_TEXT_FLAG                          0x0040
#define PRESS_HANDLER_FLAG                      0x0080
#define RELEASE_HANDLER_FLAG                    0x0100
#define REPEAT_FLAG                             0x0200
#define TEXT_UPDATE_PRESS_FLAG                  0x0400
#define TEXT_UPDATE_RELEASE_FLAG                0x0800
#define GRAPHICS_UPDATE_PRESS_FLAG              0x1000
#define GRAPHICS_UPDATE_RELEASE_FLAG            0x2000
#define C_STYLE_TEXT_FLAG                       0x4000
#ifndef BEEP_FLAG
#define BEEP_FLAG                               0x8000
#endif        
// Menu Constants
#define MENU_MASK                               0x0C00
#define INIT_ACTION                             0x0400
#define UNINIT_ACTION                           0x0800
#define BUTTON_NULL                             0xFFFF
#define BUTTON_NONLOCAL                         0xFFFE
#define DEFAULT_REPEAT_PERIOD                   0x0010
#define DEFAULT_REPEAT_DELAY                    0x0080

#endif      // __QED_GUI_LIB__
#include <mosaic/gui_tk/fr_large.h>



extern _forth  void Update_Here_With( addr address,       addr * graphics_resource_addr,       page graphics_resource_page,       FORTH_ARRAY * garray_addr,       page garray_page );

extern _forth  void Update_Graphics ( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Update_Text( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Update_Text_And_Graphics( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Clear_Graphics( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Clear_Text( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Set_Text_Home_Addr( addr address );

extern _forth  void Set_Gr_Home_Addr( addr address );

extern _forth  void Set_Text_Area( uint columns );

extern _forth  void Set_Gr_Area( uint columns );

extern _forth  void Set_Display_Mode( uint columns );

extern _forth  void Set_Cursor_State( boolean isvisible, boolean isflashing );

extern _forth  void Set_Display_State( boolean graphics, boolean text );

extern _forth  void Set_Text_Mode( uchar modebyte );

extern _forth  void Config_Display( uint graphics_cols, uint graphics_rows, addr graphics_start, uchar background_fill, uint text_cols, uint text_rows, addr text_start, xaddr heap_bottom, xaddr heap_top, GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Init_Display( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Std_Display( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Draw_Graphic( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       xaddr graphic_addr );

extern _forth  void Direct_Draw_Graphic( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       xaddr graphic_addr );

extern _forth  void Direct_Erase_Graphic( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       xaddr graphic_addr );

extern _forth  void Erase_Graphic( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       xaddr graphic_addr );

extern _forth  void Do_Graphic ( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       uint action,       xaddr graphic_addr );

extern _forth  void Button_Draw_Textonly( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr );

extern _forth  void Button_Draw( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr );

extern _forth  void Button_Erase_Textonly( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr );

extern _forth  void Button_Erase( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr );

extern _forth  void Button_Press( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr );

extern _forth  void Button_Repeat( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr );

extern _forth  void Button_Release( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr );

extern _forth  void Do_Button( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       uint action,       BUTTON * button_addr );

extern _forth  void Do_Menu(   uint col,   uint row,   GUI_VARS * tvars_addr,   page tvars_page,   uint action,   MENU * menu_addr );

extern _forth  void Menu_Install( uint offset,   uint col,   uint row,   GUI_VARS * tvars_addr,   page tvars_page,   MENU *  menu_addr );

extern _forth  void Menu_Remove(   uint offset,   GUI_VARS * tvars_addr,   page tvars_page,   MENU *  menu_addr );

extern _forth  void Init_Menu(   uint offset,   uint col,   uint row,   GUI_VARS * tvars_addr,   page tvars_page,   MENU * menu_addr );

extern _forth  void Uninit_Menu(   uint offset,   uint col,   uint row,   GUI_VARS * tvars_addr,   page tvars_page,   MENU * menu_addr );

extern _forth  void Set_Pixel ( int x, int y );

extern _forth  void Clear_Pixel(int x, int y);

extern _forth  int Is_Pressed ( void );

extern _forth  void Wait_For_Press ( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Wait_For_Release ( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  int Read_Touchscreen ( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  long Read_Raw_Coords ( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Calibrate_Touchscreen( long raw0, long raw1, long raw2 );

extern _forth  void Globalize_TVars ( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  int Screen_To_Image ( xaddr buffer, int buffer_size, int format );

extern _forth  int Graphic_To_Image ( xaddr graphic, xaddr buffer, int buffer_size, int format );

extern _forth  long Simulate_Touch ( int x, int y );

extern _forth  void Screen_Has_Changed ( void );

extern _forth  int Has_Screen_Changed ( void );

extern _forth  int Simulated_Touch_To_Image ( long buffer, int buffer_size, int format_id, int x, int y );

extern _forth  void Service_Touch( int buttonID, GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Menu_Process(  int buttonID, GUI_VARS * tvars_addr, page tvars_page);

extern _forth  void Wait_Then_Service_Touch( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Menu_Query(   GUI_VARS * tvars_addr,   page tvars_page );

extern _forth  void Init_Touch(   GUI_VARS * tvars_addr,   page tvars_page );

extern _forth  void Render_Font_to_buffer(  char * string_addr, page string_page,       uint col,       uint row,       FORTH_ARRAY * garray_addr, page garray_page,       FONT * font_addr,       page font_page);

extern _forth  void Render_Font(  char * string_addr, page string_page,       uint col,       uint row,       GUI_VARS * tvars_addr, page tvars_page,       FONT * font_addr,       page font_page);

extern _forth  void Direct_Render_Font( char * string_addr, page string_page,       uint col,       uint row,       GUI_VARS * tvars_addr,page tvars_page,       FONT * font_addr,       page font_page);

// End of C Header file for package: GUI_Toolkit_QSC

// This #endif statement closes the block begun at
// the front of the pre
#endif

// *** Note: be sure to #include this file before library.c, and in any other
// source files that use these kernel extension functions.
